<!DOCTYPE html>
<html>

<head>
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.3.1/jquery.min.js"></script>
</head>

<body>

  <h2>Javascript Tag checker</h2>

  Insert HTML here:
  <br>
  <textarea id="inputHtml" rows="2" cols="100"></textarea>
  <br>
  <input onclick="validateTags()" type="button" value="Validate!" />
  <p id="output"></p>

</body>
<script type="text/javascript">
  function validateTags() {
    var input = $('#inputHtml').val();
    var tags = [];
    //Find valid tags
    $.each(input.match(/(<([^\\>]+)>)/ig), function(index, value) {
      if ((value.match(/(<)/ig)).length == 1 && (value.match(/(>)/ig)).length == 1) {
        tags.push(value);
      }
    });

    function deleteTags(tag) {
      tags.splice(tag, 2);
    }

    function createExpectedTag(tag) {
      return tag.substr(0, 1) + "/" + tag.substr(1)
    }

    function verifyOpeningTag(closinTag) {
      openingTag = tags[closinTag[0] - 1]
      if (!openingTag) {
        $('#output').text("Expected # found " + closinTag[1]);
        return false;
      }
      expectedTag = createExpectedTag(openingTag);
      if (expectedTag == closinTag[1]) {
        deleteTags(closinTag[0] - 1);
      } else {
        $('#output').text("Expected " + expectedTag + " found " + closinTag[1]);
        return false;
      }
    }

    function findFirstClosingTag() {
      var firstClosingTag = [];
      $.each(tags, function(index, value) {
        if (value.match(/(\/)/)) {
          firstClosingTag = [index, value];
          return false;
        }
      });
      return firstClosingTag;
    }

    // Loop while there are tag pairs
    while (tags.length > 1) {
      var firstClosingTag = findFirstClosingTag();
      if (verifyOpeningTag(firstClosingTag) == false) {
        return false;
      }
    }

    // if no more pairs check what is left
    if (tags.length == 0) {
      $('#output').text("Correctly tagged paragraph");
    } else {
      if (tags[0].match(/(\/)/)) {
        $('#output').text("Expected # found " + tags[0]);
      } else {
        $('#output').text("Expected " + createExpectedTag(tags[0]) + " found #");
      }
    }
  }
</script>

</html>
